Checkout Handler
Integrate Dodo Payments checkout into your Express app.
Customer Portal
Allow customers to manage subscriptions and details.
Webhooks
Receive and process Dodo Payments webhook events.
Installation
1
Install the package
Run the following command in your project root:
2
Set up environment variables
Create a
.env file in your project root:Route Handler Examples
- Checkout Handler
- Customer Portal Handler
- Webhook Handler
Use this handler to integrate Dodo Payments checkout into your Express app. Supports static (GET), dynamic (POST), and session (POST) payment flows.
Checkout Route Handler
Dodo Payments supports three types of payment flows for integrating payments into your website, this adaptor supports all types of payment flows.
- Static Payment Links: Instantly shareable URLs for quick, no-code payment collection.
- Dynamic Payment Links: Programmatically generate payment links with custom details using the API or SDKs.
- Checkout Sessions: Create secure, customizable checkout experiences with pre-configured product carts and customer details.
Static Checkout (GET)
Static Checkout (GET)
Supported Query Parameters
string
bắt buộc
Product identifier (e.g.,
?productId=pdt_nZuwz45WAs64n3l07zpQR).integer
Quantity of the product.
string
Customer’s full name.
string
Customer’s first name.
string
Customer’s last name.
string
Customer’s email address.
string
Customer’s country.
string
Customer’s address line.
string
Customer’s city.
string
Customer’s state/province.
string
Customer’s zip/postal code.
boolean
Disable full name field.
boolean
Disable first name field.
boolean
Disable last name field.
boolean
Disable email field.
boolean
Disable country field.
boolean
Disable address line field.
boolean
Disable city field.
boolean
Disable state field.
boolean
Disable zip code field.
string
Specify the payment currency (e.g.,
USD).boolean
Show currency selector.
integer
Specify the payment amount (e.g.,
1000 for $10.00).boolean
Show discount fields.
string
Any query parameter starting with
metadata_ will be passed as metadata.Response Format
Static checkout returns a JSON response with the checkout URL:Dynamic Checkout (POST)
Dynamic Checkout (POST)
- Send parameters as a JSON body in a POST request.
- Supports both one-time and recurring payments.
- For a complete list of supported POST body fields, refer to:
Response Format
Dynamic checkout returns a JSON response with the checkout URL:Checkout Sessions (POST)
Checkout Sessions (POST)
Checkout sessions provide a more secure, hosted checkout experience that handles the complete payment flow for both one-time purchases and subscriptions with full customization control.Refer to Checkout Sessions Integration Guide for more details and a complete list of supported fields.
Response Format
Checkout sessions return a JSON response with the checkout URL:Customer Portal Route Handler
The Customer Portal Route Handler enables you to seamlessly integrate the Dodo Payments customer portal into your Express application.Query Parameters
string
bắt buộc
The customer ID for the portal session (e.g.,
?customer_id=cus_123).boolean
If set to
true, sends an email to the customer with the portal link.Webhook Route Handler
- Method: Only POST requests are supported. Other methods return 405.
- Signature Verification: Verifies the webhook signature using
webhookKey. Returns 401 if verification fails. - Payload Validation: Validated with Zod. Returns 400 for invalid payloads.
- Error Handling:
- 401: Invalid signature
- 400: Invalid payload
- 500: Internal error during verification
- Event Routing: Calls the appropriate event handler based on the payload type.